

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT  Tracer, Performance profiling, and Coverage example
 *
 * description : Philosopher dinning
 * 		need to have right and left fork available at the same time to eat.
 *		 but left and right forks are shared with the next philosophers
 *
 */

#include "Mutx.h"

void Mutex_release( struct Mutex * const this )
{
	int result;

	if (!(result = ReleaseMutex( this->mutex )))
	{
		printf("Relase Mutex error %d\n", result);
		return;
	}
	printf("put %d\n", this->id);
}


int Mutex_take( struct Mutex * const this,int timeout )
{
	switch(WaitForSingleObject( this->mutex, timeout ))
	{
		case WAIT_OBJECT_0:
			printf("get %d\n", this->id);
			return 1;
		case WAIT_TIMEOUT:
			return 0;
		default:
		{
			printf("Lock Mutex error\n");
			return 0;
		}
	}
}


void Mutex_init( struct Mutex * const this )
{
	this->mutex = CreateMutex( NULL,FALSE,NULL);
	if( this->mutex == (HANDLE) 0 )
	{
		printf("Mutex Creation error");
	}

}
