

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT  Tracer, Performance profiling, and Coverage example
 *
 * description : Philosopher dinning
 * 		need to have right and left fork available at the same time to eat.
 *		 but left and right forks are shared with the next philosophers
 *
 */
#ifndef Mutex_H
#define Mutex_H

#include <stdio.h>
#include <stdlib.h>

#ifdef UNIX
#include <unistd.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <sys/types.h>
#include <pthread.h>
#include <thread.h>
#define LPTHREAD_START_ROUTINE void *(*)(void *)
#define CreateThread thr_create
#define SOCKET int
#define closesocket close
#define WSAECONNRESET ECONNRESET
#include <netdb.h>
#define WAIT(t) sleep(t)
#endif

#ifdef _WIN32

#include <windows.h>
#include <winbase.h>
/*#include <winsock.h>*/
#include <sys/timeb.h>
#include <signal.h>
#include <process.h>
typedef long thread_t;
#define WAIT(t) Sleep(t*1000)
#endif


struct Mutex
{
	HANDLE mutex;
	int id;
};

void Mutex_release( struct Mutex * const this );

int Mutex_take( struct Mutex * const this, int timeout );

void Mutex_init( struct Mutex * const this );

#endif /* Mutex_H */
