

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT  Tracer, Performance profiling, and Coverage example
 *
 * description : Philosopher dinning
 * 		need to have right and left fork available at the same time to eat.
 *		 but left and right forks are shared with the next philosophers
 *
 */
#define OPTIMIZE
#include "Philosopher.h"

void * Philosopher_run( struct Philosopher * const this )
{

	int count=3;
#pragma attol att_insert char note[30];
	srand(GetCurrentThreadId());
	printf("philo %d started\n", this->id);
	while(count)
	{
		if(take_right_fork(this,rand() % RAND_FACTOR))
		{
			if(take_left_fork(this,rand() % RAND_FACTOR))
			{
#pragma attol att_insert sprintf(note,"%d eating, #%d",this->id,count);
#pragma attol att_insert _ATT_USER_NOTE( note );
				printf("eating... %d\n", this->id);
				WAIT(1);
				count--;
#pragma attol att_insert sprintf(note,"%d thinking ",this->id);
#pragma attol att_insert _ATT_USER_NOTE( note );
				release_left_fork(this);
			}
			release_right_fork(this);
		}
#ifdef OPTIMIZE
		else if(take_left_fork(this,rand() % RAND_FACTOR))
		{
			if(take_right_fork(this,rand() % RAND_FACTOR))
			{
#pragma attol att_insert sprintf(note,"%d eating, #%d",this->id,count);
#pragma attol att_insert _ATT_USER_NOTE( note );
				printf("eating... %d\n", this->id);
				WAIT(1);
				count--;
#pragma attol att_insert sprintf(note,"%d thinking ",this->id);
#pragma attol att_insert _ATT_USER_NOTE( note );
				release_right_fork(this);
			}
			release_left_fork(this);
		}
#endif
		printf("thinking... %d\n", this->id);
		WAIT(1);
	}

#pragma attol att_insert sprintf(note,"philo %d finished",this->id);
#pragma attol att_insert _ATT_USER_NOTE( note );

	printf("philo %d finished\n", this->id);
	return (void *)0;
}

void philo_init(void)
{
}

