

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT  Tracer, Performance profiling, and Coverage example
 *
 * description : Philosopher dinning
 * 		need to have right and left fork available at the same time to eat.
 *		 but left and right forks are shared with the next philosophers
 *
 */
#ifndef Philosopher_H
#define Philosopher_H

#include "Mutx.h"
#define MAX_WAIT 2

#define RAND_FACTOR ((RAND_MAX) % (MAX_WAIT * 1000) )

struct Philosopher
{
	int id;
	struct Mutex * rightFork;
	struct Mutex * leftFork;
};

void * Philosopher_run( struct Philosopher * const this );
int take_right_fork( struct Philosopher * const this ,int timeout );
int take_left_fork ( struct Philosopher * const this ,int timeout );
void release_right_fork(struct Philosopher * const this);
void release_left_fork(struct Philosopher * const this);
void philo_init(void);
void fork_init(void);
#endif /* Philosopher_H */
