

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*
 * RTRT  Tracer, Performance profiling, and Coverage example
 *
 * description : Philosopher dinning
 * 		need to have right and left fork available at the same time to eat.
 *		 but left and right forks are shared with the next philosophers
 *
 */
#include "Philosopher.h"

int take_right_fork( struct Philosopher * const this ,int timeout )
{
	return (Mutex_take( this->rightFork, timeout ));
}
int take_left_fork ( struct Philosopher * const this ,int timeout )
{
	return (Mutex_take( this->leftFork,  timeout ));
}

void release_right_fork(struct Philosopher * const this)
{
	Mutex_release(this->rightFork);
}
void release_left_fork(struct Philosopher * const this)
{
	Mutex_release(this->leftFork);
}

void fork_init(void)
{
}
