

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include <stdio.h>
#include "LeftHandPhilosopher.h"

// ========================================================================
// Constructor of a philosopher
LeftHandPhilosopher::LeftHandPhilosopher (MaitreDHote& theBoss)
  : Philosopher (theBoss)
{
}

// ========================================================================
// When the philosopher has one fork it tries to get the one on the right for
// a period of 0,01 seconds. If it can't acquire the fork it will release all
// forks and sleep for 0,2 seconds.

void LeftHandPhilosopher::doHasOneFork ()
{
  if (theRightFork->GetFork (*this, 10))
    setState (hasTwoForks);
  else
    {
      // Didn't get the right fork so release the left fork
      theLeftFork->Release();
      Sleep (200);
      setState (hasNoForks);
    }
}

