

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include <stdio.h>
#include "OneHandedPhilosopher.h"

// ========================================================================
// Constructor of a philosopher
OneHandedPhilosopher::OneHandedPhilosopher (MaitreDHote& theBoss)
  : Philosopher (theBoss)
{
}

// ========================================================================
// When the philosopher hasn't any forks it tries to get the one on the left.

void OneHandedPhilosopher::doHasNoForks ()
{
  theLeftFork->GetFork (*this, INFINITE);

  // This philosopher cheats by only taking one fork and prenting that it
  //has two
  setState (hasTwoForks);
}

// ========================================================================
// The philosopher takes some time to eat then starts thinking

void OneHandedPhilosopher::doIsEating ()
{
  // 0,02 seconds
  Sleep (20);
  setState (isThinking);
}

// ========================================================================
// Before thinking the philosopher releases the forks

void OneHandedPhilosopher::doIsThinking ()
{
  theLeftFork->Release();
  // Think for 0,02 seconds
  Sleep (20);
  numberOfTimesEaten++;
  if (hasEatenEnough())
    setState (finishedEating);
  else
    setState (hasNoForks);
  char note[256];
  sprintf (note, "Eaten %d times", numberOfTimesEaten);
#pragma attol att_insert _ATT_USER_NOTE (note)
}
