

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef RIGHTHANDPHILOSOPHER_H
#define RIGHTHANDPHILOSOPHER_H

#include "philosopher.h"

class RightHandPhilosopher : public Philosopher {

  // The right handed philospher takes the right fork first, then tries for the
  // left hand fork. If she can't get it then she releases the right fork and
  // tries again after a pause. 

public:

  // Constructor
  RightHandPhilosopher (MaitreDHote& theBoss);

  // The functions that handle each state and change it. They are virtual so
  // they can be overwritten
  virtual void doHasNoForks ();
  virtual void doHasOneFork();
};

  
#endif
