

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include <stdio.h>
#include "SlowPhilosopher.h"

// ========================================================================
// Constructor of a philosopher
SlowPhilosopher::SlowPhilosopher (MaitreDHote& theBoss)
  : Philosopher (theBoss)
{
}

// ========================================================================
// When the philosopher hasn't any forks it tries to get the one on the left.

void SlowPhilosopher::doHasNoForks ()
{
  theLeftFork->GetFork (*this, INFINITE);
  setState (hasOneFork);
  Sleep (500);
}

// ========================================================================
// When the philosopher has one fork and waits for the second to be available

void SlowPhilosopher::doHasOneFork ()
{
  if (theRightFork->GetFork (*this, INFINITE))
    setState (hasTwoForks);
}

// ========================================================================
// When the philosopher has both forks it informs the maitre d'hote
// and starts eating

void SlowPhilosopher::doHasTwoForks ()
{
  setState (isEating);
  theMaitreDHote.amEating(*this);
}

// ========================================================================
// The philosopher takes some time to eat then starts thinking

void SlowPhilosopher::doIsEating ()
{
  // 0,2 seconds
  Sleep (200);
  setState (isThinking);
}

