

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef SLOWPHILOSOPHER_H
#define SLOWPHILOSOPHER_H

#include "philosopher.h"

class SlowPhilosopher : public Philosopher {

  // The slow philospher takes the left fork first, then waits forever 
  // for the right hand fork. Each call is blocking
  // forever. This means that too many slow philosphers around the
  // table may cause a deadlock

public:

  // Constructor
  SlowPhilosopher (MaitreDHote& theBoss);

  // The functions that handle each state and change it. They are virtual so
  // they can be overwritten
  virtual void doHasNoForks ();
  virtual void doHasOneFork();
  virtual void doHasTwoForks();
  virtual void doIsEating();
};

  
#endif
