

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include "fork.h"

// ========================================================================
// Construct the mutex behind the fork
Fork::Fork ()
{
  // Create the mutex
  ptheMutex = Mutex::getNewMutex();
  theOwner = 0;
}

// ========================================================================
// Destroy the mutex if it has been created
Fork::~Fork ()
{
  // Destroy the mutex
  delete ptheMutex;
}

// ========================================================================
// Get the fork for the given philosopher but only wait maxTime for the
// fork
bool Fork::GetFork (Philosopher& theAskingPhilosospher, int maxTime)
{
  if (ptheMutex->getMutex(maxTime)) {
    theOwner = &theAskingPhilosospher;
    return true;
  }
  else
    return false;
}


// ========================================================================
// Releases the fork for use by another philosopher
void Fork::Release ()
{
  ptheMutex->releaseMutex();
  theOwner = 0;
}
