

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef FORK_H
#define FORK_H

#include <mutex.h>

class Philosopher;

class Fork {
  
 private:
  
  // The "owner" of the fork
  Philosopher* theOwner;
  
  // The handle of the mutex
  Mutex* ptheMutex;

 public:
  // Constructor
  Fork ();

  // Constructor
  ~Fork ();

  // Tries to acquire a fork during a given time period.
  // Returns true if succesful false if it timesout
  bool GetFork (Philosopher& theAskingPhilosospher, int maxTime);

  // Releases the fork for use by another philosopher
  void Release ();
};

#endif
