

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef MAITREDHOTE_H
#define MAITREDHOTE_H

#include <windows.h>

class Philosopher;
class Fork;

class MaitreDHote {

private:

  // The list of the diners
  int numberOfPhilosophers;
  Philosopher** thePhilosophers;

  // The list of forks
  Fork** theForks;

  // The number of philosophers eating
  bool someoneHasEaten;

  // The handle of the watchdog timer
  HANDLE watchdogThread;

  // Allocates a new philospher according to the command line arguments
  Philosopher* newPhilosopher (int index, int argc, char** argv);

  // Creates and seats the philosophers at the table with the forks
  void seatPhilosophers(int argc, char** argv);

public:
  // Constructor
  MaitreDHote ();

  // Destructor to clean up
  ~MaitreDHote();

  // Starts the Dinner Party
  void Dine(int argc, char** argv);

  // The main thread routine
  void run();

  // Informs the MaitreDHote that a philosopher is eating
  void amEating (Philosopher& aPhilosopher);

  // Informs the MaitreDHote that a philosopher has finished eating
  void finishedEating (Philosopher& aPhilosopher);

  // Returns true if someone has eaten since the last call to the function
  bool hasAnyoneEaten();

  // Returns true if all the diners have finished eating
  bool allHaveFinished();

  // Exception classes
  class createWatchdogFailed { };
  class invalidPhilospher { };
};

#endif
