

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef THREAD_H
#define THREAD_H

class Thread {
 protected:
  // You must use  the static function to create a new mutex object
  Thread() {};
  Thread(const Thread& m);

 public:
  // Returns a new Thread object. Throws an exception in case of error 
  // (ThreadCreationFailed).
  static Thread* getNewThread(int (*threadMain)(void*),
			      void* threadMainParameter);

  // Destroys the mutex
  virtual ~Thread() = 0;

  // Make the thread continue executing
  virtual void resumeThread () = 0;

  // Returns true if the thread has finished
  virtual bool isFinished(int maxTime) = 0;

  // Exception classes
  class createThreadFailed { };

};

#endif
