

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include "windowsmutex.h"

// ===========================================================================
WindowsMutex::WindowsMutex()
{
  theMutex = CreateMutex( NULL,FALSE,NULL);
  if (theMutex == (HANDLE)0)
    throw new MutexCreationFailed;
}


// ===========================================================================
WindowsMutex::~WindowsMutex()
{
  // Destroy the mutex
  if (theMutex != (HANDLE)0)
    ; // DeleteMutex (theMutex);
}


// ===========================================================================
bool WindowsMutex::getMutex (int maxTimeInMilliSeconds)
{
  // Try and get the mutex with the specified maxTime
  switch(WaitForSingleObject( theMutex, maxTimeInMilliSeconds )) {
  case WAIT_OBJECT_0:
    return true;
  case WAIT_TIMEOUT:
    return false;
  case WAIT_ABANDONED:
    #pragma attol att_insert _ATT_USER_NOTE ("Thread terminated before releasing mutex")
    return true;
  default:
    throw new MutexLockFailed;
  }
}

// ===========================================================================
void WindowsMutex::releaseMutex()
{
  if (!ReleaseMutex (theMutex))
    throw new MutexReleaseFailed;
}

