

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef WINDOWSMUTEX_H
#define WINDOWSMUTEX_H

#include "mutex.h"
#include <windows.h>

class WindowsMutex : public Mutex {

private:
  // The handle of the mutex
  HANDLE theMutex;

public:
  // Returns a new Mutex object. Throws an exception in case of error 
  // (MutexCreationFailed).
  WindowsMutex();

  // Destroys the mutex
  virtual ~WindowsMutex();

  // Returns true if the mutex was obtained with the given time. false
  // otherwise. Throws an exception in case of error (MutexLockFailed).
  virtual bool getMutex (int maxTimeInMilliSeconds);
 
  // Releases the mutex. Throws an exception in case of error
  // (MutexReleaseFailed).
  virtual void releaseMutex();
};
#endif
