

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */



#include "winthread.h"
#include <windows.h>

WinThread::WinThread(int (*threadMain)(void*), void* threadMainParameter)
{
  myThread = CreateThread( 0, 0,
			   (LPTHREAD_START_ROUTINE)threadMain,
			   (LPVOID)threadMainParameter, CREATE_SUSPENDED, 0 );
  if (myThread == (HANDLE)0)
    throw new createThreadFailed;
}

// ===========================================================================

WinThread::~WinThread ()
{
}

// ===========================================================================

bool WinThread::isFinished(int maxTime)
{
  switch(WaitForSingleObject (myThread, maxTime)) {
  case WAIT_OBJECT_0:
    return true;
  case WAIT_TIMEOUT:
    return false;
  case WAIT_ABANDONED:
    return false;
  default:
    return false;
  }
}

// ===========================================================================

void WinThread::resumeThread ()
{
  ResumeThread (myThread);
}
