

/* 
 *  Licensed Materials - Property of IBM
 *  Use Restricted Material of IBM - please refer to the "Samples Code" terms and conditions in the IBM International Program License Agreement (IPLA).
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


#ifndef WINTHREAD_H
#define WINTHREAD_H

#include <windows.h>
#include "thread.h"

class WinThread : public Thread {
private:

  // The handle of the philosophers thread
  HANDLE myThread;

public:
  // Creates new thread
  WinThread(int (* pFunc)(void*), void* threadMainParameter);

  // Destroys the mutex
  virtual ~WinThread();

  // Returns true if the thread has finished
  virtual bool isFinished(int maxTime);

  // Make the winthread continue executing
  virtual void resumeThread ();
};

#endif
